﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DatoClassLibrary
{
    public class Dato
    {
        private int datoen = 19990921;

        public Dato(int år, int måned, int dag) // Constructor
        {
            this.datoen = (år * 10000) + (måned * 100) + dag;
        }

        public int GetAar()
        {
            int år;
            år = this.datoen / 10000;
            return år;
        }
        public void SetAar(int år)
        {
            this.datoen = (år * 10000) + (this.datoen % 10000);
        }
        public int GetMaaned()
        {
            int md = (this.datoen%10000)/100;
            return md;
        }
        public void SetMaaned(int måned)
        {
            int år = GetAar();
            int dag = GetDag();
            this.datoen = (år * 10000) + (måned * 100) + dag;
        }
        public int GetDag()
        {
            int dag = this.datoen % 100;
            return dag;
        }
        public void SetDag(int dag)
        {
            int år = GetAar();
            int måned = GetMaaned();
            this.datoen = (år * 10000) + (måned * 100) + dag;
        }


        public int GetKvartalUdregnet()
        {
            int kvartal = 2;
            int måned = (this.datoen % 10000) / 100;

            kvartal = ((måned-1) / 3)+1;

            return kvartal;
        }
        public int GetKvartal()
        {
            int kvartal = 4;
            int måned = (this.datoen % 10000) / 100;
            if (måned == 1 || måned == 2 || måned == 3)
            {
                kvartal = 1;
            }
            else if (måned <= 6)
            {
                kvartal = 2;
            }
            else if (måned <= 9)
            {
                kvartal = 3;
            }
            //else if (måned <= 12)
            //{
            //    kvartal = 4;
            //}


            return kvartal;
        }
        
        public void MoveToNextDate()
        {
            //this.datoen = this.datoen + 1; 
            int år = GetAar();
            int måned = GetMaaned();
            int dag = GetDag();
            int dageIMd = AntalDageIMåneden();
            dag = dag + 1;
            SetDag(dag);
            if (dag > dageIMd)
            {
                dag = 1;
                SetDag(dag);
                måned = måned + 1;
                SetMaaned(måned);
                if (måned > 12)
                {
                    måned = 1;
                    SetMaaned(måned);
                    år = år + 1;
                    SetAar(år);
                }
            }


        }

        public int AntalDageIMåneden()
        {
            int antDageIMd = 31;
            int måned = (this.datoen % 10000) / 100;
            if (måned == 2)
            {
                antDageIMd = 28 + AntalSkudDage();
            }
            else if (måned == 4 || måned == 6 || måned == 9 || måned == 11)
            {
                antDageIMd = 30;
            }

            return antDageIMd;
        }
        public int AntalSkudDage()
        {
            int skud = 0;


            return skud;
        }

        public void MoveDays(int antalDage)
        {
            if (0 < antalDage)
            {
                // flyt dato antalDage frem
                while (0 < antalDage)
                {
                    MoveToNextDate();
                    antalDage = antalDage - 1;
                }
            }
            else if (antalDage < 0)
            {
                // flyt dato -antalDage tilbage
            }
        }


        public override string ToString()
        {
            return ""+this.datoen;
        }
    }
}
